package dao;

import java.util._;
import java.sql.ResultSet;
import org.springframework.jdbc.core.simple.{ParameterizedRowMapper,SimpleJdbcTemplate};
import org.springframework.jdbc.core.support.JdbcDaoSupport;

object PersonDao extends JdbcDaoSupport {
  override def initTemplateConfig() = super.initTemplateConfig();  
  def simpleTemplate = new SimpleJdbcTemplate(getJdbcTemplate());

  def countAuthor():int = 
        simpleTemplate.queryForInt("select count(*) from person", 
            Array[java.lang.Object]());
  
  def findAllAuthor():List =
        simpleTemplate.query("select id,name,mail_address from person",
            new ParameterizedRowMapperImpl, Array[java.lang.Object]());
  
  class ParameterizedRowMapperImpl extends ParameterizedRowMapper {
    def mapRow(rs:ResultSet, rowNum:int):Person
      = new Person(rs.getInt("id"), rs.getString("name"), rs.getString("mail_address"));
  }
}
